#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_NoviceAchievementCFG.h"
std::auto_ptr<M_NoviceAchievementCFG> M_NoviceAchievementCFG::msSingleton(nullptr);

int M_NoviceAchievementCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_NoviceAchievementCFGData* M_NoviceAchievementCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_NoviceAchievementCFGData>& M_NoviceAchievementCFG::GetMapData()
{
	return mMapData;
}

void M_NoviceAchievementCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_NoviceAchievementCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_NoviceAchievementCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mGroup = element->IntAttribute("Group");
		data.mDes = element->Attribute("Des");
		data.mCompleteType = element->IntAttribute("CompleteType");
		data.mCompleteParam = element->IntAttribute("CompleteParam");
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mGoType = element->IntAttribute("GoType");
		{
			const char* FindRand = element->Attribute("FindRand");
			std::vector<std::string> vecFindRand;
			boost::split(vecFindRand, FindRand, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFindRand.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFindRand[i].c_str(), &temp))
				{
					data.mFindRand.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_NoviceAchievementCFG Loaded. Load Data:%u", mMapData.size());
}

void M_NoviceAchievementCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_NoviceAchievementCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_NoviceAchievementCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_NoviceAchievementCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Group", data.mGroup);
		LuaCfgHelper::readString(L, "Des", data.mDes);
		LuaCfgHelper::readInt(L, "CompleteType", data.mCompleteType);
		LuaCfgHelper::readInt(L, "CompleteParam", data.mCompleteParam);
		LuaCfgHelper::readInt(L, "CompleteCount", data.mCompleteCount);
		LuaCfgHelper::readVectorInt(L, "AwardItemIDs", data.mAwardItemIDs);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readInt(L, "GoType", data.mGoType);
		LuaCfgHelper::readVectorInt(L, "FindRand", data.mFindRand);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_NoviceAchievementCFG Loaded. Load Data:%u", mMapData.size());
}

void M_NoviceAchievementCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_NoviceAchievementCFG* M_NoviceAchievementCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_NoviceAchievementCFG());
	}
	return msSingleton.get();
}

void M_NoviceAchievementCFG::Release()
{
	msSingleton.reset(nullptr);
}
